unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, StdVcl, strutils, ExtCtrls;

type

  TWorker = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;

  TWatchDog = class(TThread)
  private
    { Private declarations }

  public
    th: TThread;
    TimeTowait: cardinal;

  protected
    procedure Execute; override;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  worker: TWorker;

implementation

{$R *.dfm}

procedure RaizeThreadAbort;
begin
  // alan thread buraya ynlendirilir.
 // raise EThreadAbort.Create('Thread was aborted using AbortThread()');
end;

procedure ThreadKill(const Th: TThread);
const //ThreadKill, threadterminate fonk. yerine kullanlr. hafza tamas yapmaz. thread geleri komple silinir
  AlignAt = SizeOf(DWORD); // Undocumented; Apparently the memory used for _CONTEXT needs to be aligned on DWORD boundary
var
  Block: array[0..SizeOf(_CONTEXT) + 512] of Byte;
  // The _CONTEXT structure is probably larger then what Delphi thinks it should be. Unless I provide enough padding space, GetThreadContext fails
  ThContext: PContext;
begin
  SuspendThread(Th.Handle);
  ZeroMemory(@Block, SizeOf(Block));
  ThContext := PContext(((Integer(@Block) + AlignAt - 1) div AlignAt) * AlignAt);
  ThContext.ContextFlags := CONTEXT_FULL;
  if not GetThreadContext(Th.Handle, ThContext^) then
    RaiseLastOSError;
  ThContext.Eip := Cardinal(@RaizeThreadAbort); // Change EIP so we can redirect the thread to our error-raizing routine
  SetThreadContext(Th.Handle, ThContext^);
  ResumeThread(Th.Handle);
end;

procedure TWorker.Execute;

var
  dog: TWatchDog;

begin

  dog := TWatchDog.Create(true); // dog: kendisini ldrecek thread
  dog.th := self;
  dog.TimeTowait := 5000;
  dog.Resume;

  while not terminated do
  begin
    windows.beep(5000, 50); // "Yayorum" mesaj.
    sleep(500);

    // Sre bitmeden  katilin iine son vermek isterse
    //  ThreadKill(dog); // katili ldr

  end;

end;

procedure TWatchDog.Execute;
begin
  sleep(timetowait);
  windows.Beep(3000, 500); // Sre tamam. Ate ediyor

  if assigned(th) then
    ThreadKill(th);

end;

procedure TForm1.Button1Click(Sender: TObject);

begin

  worker := tworker.Create(false);

end;

end.
